package checkers.nonnull;

import java.lang.annotation.Annotation;

import checkers.quals.*;
import checkers.types.*;

public class NonnullAnnotatedClassType extends AnnotatedClassType {

    @Override
    public boolean hasAnnotationAt(Class<? extends Annotation> annotation, AnnotationLocation location) {
        
        // Override to false if Nullable is present.
        if (annotation == NonNull.class && hasAnnotationAt(Nullable.class, location))
            return false;
        
        return super.hasAnnotationAt(annotation, location);
    }

    @Override
    public boolean isAnnotatedWith(Class<? extends Annotation> annotation) {
        
        // Override to false if Nullable is present.
        if (annotation == NonNull.class && isAnnotatedWith(Nullable.class))
            return false;
        
        return super.isAnnotatedWith(annotation);
    }
    
}
